"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CodeMirror = void 0;

var _react = _interopRequireDefault(require("react"));

var _view = require("@codemirror/view");

var _state = require("@codemirror/state");

var _useCodeMirror3 = require("@ui-schema/kit-codemirror/useCodeMirror");

var _useEditorClasses = require("@ui-schema/kit-codemirror/useEditorClasses");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var CodeMirror = function CodeMirror(_ref) {
  var className = _ref.className,
      classNamesContent = _ref.classNamesContent,
      onChange = _ref.onChange,
      onViewLifecycle = _ref.onViewLifecycle,
      _ref$value = _ref.value,
      value = _ref$value === void 0 ? '' : _ref$value,
      style = _ref.style,
      extensions = _ref.extensions;

  var containerRef = _react["default"].useRef(null);

  var editorAttributesCompartment = _react["default"].useRef(new _state.Compartment());

  var extensionsAll = _react["default"].useMemo(function () {
    return [editorAttributesCompartment.current.of(_view.EditorView.editorAttributes.of({}))].concat(_toConsumableArray(extensions || []));
  }, [extensions]);

  var _useCodeMirror = (0, _useCodeMirror3.useCodeMirror)(containerRef, onChange, value, extensionsAll),
      _useCodeMirror2 = _slicedToArray(_useCodeMirror, 1),
      editor = _useCodeMirror2[0];

  (0, _useEditorClasses.useEditorClasses)(editorAttributesCompartment.current, editor, classNamesContent);

  _react["default"].useEffect(function () {
    if (!onViewLifecycle || !editor) return;
    onViewLifecycle(editor);
    return function () {
      return onViewLifecycle(undefined);
    };
  }, [onViewLifecycle, editor]);

  return _react["default"].createElement("div", {
    className: className,
    style: style,
    ref: containerRef
  });
};

exports.CodeMirror = CodeMirror;